/*
 * Copyright (C) 2010 - Paulo Ricardo Zanoni <pzanoni@mandriva.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
 * USA.
 */

#ifndef CRTCINFO_H
#define CRTCINFO_H

#include <string>
#include <list>

#include <X11/Xlib.h>
#include <X11/extensions/Xrandr.h>

class CrtcInfo
{
    public:
	RRCrtc xid;
	int x, y;
	unsigned int width, height;

	RRMode mode;
	std::list<RROutput> outputs;
	Time timestamp;
	Rotation rotation;

	CrtcInfo(Display *display, XRRScreenResources *res, RRCrtc x_crtc);
	void update_info(Display *display, XRRScreenResources *res);

	bool rotation_is_supported(Rotation rotation);

    private:
	Rotation supported_rotations;

};

#endif
