/*
 * Copyright (C) 2010 - Paulo Ricardo Zanoni <pzanoni@mandriva.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
 * USA.
 */

#ifndef EXTENDDESKTOPWIDGET_H
#define EXTENDDESKTOPWIDGET_H

#include <QWidget>
#include <QtGui>

#include <X11/extensions/Xrandr.h> // XXX just for RROutput

class ExtendDesktopWidget: public QWidget
{
    Q_OBJECT

    public:
	ExtendDesktopWidget(QWidget *parent = 0);
	~ExtendDesktopWidget();

	bool is_extended();
	void set_extended(bool extended);
	void set_items(QList<QPair<RROutput, QString*>* > items);
	void add_output(RROutput output, std::string output_name);
	void remove_output(RROutput output);
	QList<RROutput> get_outputs_in_order();

    private slots:
	void left_btn_click();
	void right_btn_click();

    private:
	enum Direction { Left, Right };

	QTableWidget *table;
	QCheckBox *extend_box;
	QPushButton *left_btn, *right_btn;

	void update_table_size();
	void move_selected_column(Direction dir);
	void add_table_item(int column, QString name, RROutput id);
};

#endif
