/*
 * Copyright (C) 2010 - Paulo Ricardo Zanoni <pzanoni@mandriva.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
 * USA.
 */

#include <ModeInfo.h>

#include <iostream>
#include <sstream>
using namespace std;

ModeInfo::ModeInfo(XRRModeInfo *mode_info)
{
    xid = mode_info->id;

    update_info(mode_info);
}

void ModeInfo::update_info(XRRModeInfo *mode_info)
{
    double frequency;
    stringstream aux;

    //name = mode_info->name;
    width = mode_info->width;
    height = mode_info->height;

    dotClock = mode_info->dotClock;
    frequency = ((double) dotClock /
		 ((double) mode_info->hTotal * (double) mode_info->vTotal));

    aux.setf(ios::fixed, ios::floatfield);
    aux.precision(0);
    aux << mode_info->name << " @" << frequency << "Hz";
    name = aux.str();
}
