/*
 * Copyright (C) 2010 - Paulo Ricardo Zanoni <pzanoni@mandriva.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
 * USA.
 */

#include <OutputInfo.h>

OutputInfo::OutputInfo(Display *display,
		       XRRScreenResources *res,
		       RROutput x_output)
{

    xid = x_output;

    update_info(display, res);
}

void OutputInfo::update_info(Display *display, XRRScreenResources *res)
{
    int i;
    XRROutputInfo *output_info;

    output_info = XRRGetOutputInfo(display, res, xid);
    name = output_info->name;
    crtc = output_info->crtc;
    connection = output_info->connection;
    modes.clear();
    for (i = 0; i < output_info->nmode; i++) {
	if (i == output_info->npreferred) {
	    preferred_mode = output_info->modes[i];
	}
	modes.push_back(output_info->modes[i]);
    }
    XRRFreeOutputInfo(output_info);
}
