/*
 * Copyright (C) 2010 - Paulo Ricardo Zanoni <pzanoni@mandriva.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
 * USA.
 */

#ifndef OUTPUTINFO_H
#define OUTPUTINFO_H

#include <string>
#include <list>

#include <X11/Xlib.h>
#include <X11/extensions/Xrandr.h>

class OutputInfo
{
    public:
	RROutput xid;
	std::string name;
	RRCrtc crtc;
	Connection connection;
	std::list<RRMode> modes;
	RRMode preferred_mode;

	OutputInfo(Display *display, XRRScreenResources *res, RROutput x_output);
	void update_info(Display *display, XRRScreenResources *res);

};

#endif
