/*
 * Copyright (C) 2010 - Paulo Ricardo Zanoni <pzanoni@mandriva.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
 * USA.
 */

#ifndef YARGWINDOW_H
#define YARGWINDOW_H

#include <QWidget>

#include "OutputWidget.h"
#include "ExtendDesktopWidget.h"
#include "RandrInfo.h"

class YargWindow : public QWidget
{
    Q_OBJECT

    public:
        YargWindow(QWidget *parent = 0);
	~YargWindow();

    private slots:
        void update_btn_click();
	void apply_btn_click();
	void hide_btn_click();
	void tray_icon_activated(QSystemTrayIcon::ActivationReason reason);
	void ow_output_changed(RROutput output, RRMode mode, Rotation rotation);

    private:
	RandrInfo *randr_info;
	QList<OutputWidget *> output_widgets;
	QIcon *icon;
	QFile *config_file;
	QSystemTrayIcon *tray_icon;
	QX11Info *x11_info;
	ExtendDesktopWidget *extend_widget;

	void apply_config(bool do_save_config);
	void configure_outputs(bool extend_desktop);
	void update_info(bool do_save_config = true);
	bool x11Event(XEvent *event);
	void closeEvent(QCloseEvent *event);
	void error_dialog(QString text = NULL, QString informative_text = NULL);
	void save_config();
	void load_config();
	void update_extend_widget();
};

#endif
